using System;
namespace Krvne_grupe
{
    class Program
    {
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine());
            string[] zalihe = new string[4];
            string s = Console.ReadLine();
            zalihe = s.Split(' ');
            int O = int.Parse(zalihe[0]);
            int A = int.Parse(zalihe[1]);
            int B = int.Parse(zalihe[2]);
            int AB = int.Parse(zalihe[3]);
            string [] grupa= new string[N];
            int[] broj_j= new int[N];
            int[] doze = new int[4];
            for (int i = 0; i < N; i++)
            {
                string s1 = Console.ReadLine();
                string[] p = s1.Split(' ');
                grupa[i] = p[0];
                broj_j[i] = int.Parse(p[1]);
            }

            for (int i = 0;i < N; i++)
            {
                if(grupa[i]== "O")
                {
                    if (O < broj_j[i])
                    {
                        Console.WriteLine("nemoguce");
                        break;
                    }
                    else O -= broj_j[i];
                    doze[0] += broj_j[i];
                }
                if(grupa[i]=="A")
                {
                    if (A < broj_j[i] && O < broj_j[i])
                    {
                        Console.WriteLine("nemoguce");
                        break;
                    }
                    else if (A > broj_j[i]) { A -= broj_j[i]; doze[1] += broj_j[i]; }
                    else
                    {
                        O -= broj_j[i];
                        doze[0] += broj_j[i];
                    }
                }
                if (grupa[i] == "B")
                {
                    if (B < broj_j[i] && O < broj_j[i])
                    {
                        Console.WriteLine("nemoguce");
                        break;
                    }
                    else if (B > broj_j[i]) { B -= broj_j[i]; doze[2] += broj_j[i]; }
                    else { O -= broj_j[i]; doze[0] += broj_j[i]; }



                }
                if (grupa[i] == "AB")
                {
                    if (B < broj_j[i] && O < broj_j[i] && A < broj_j[i] && AB < broj_j[i])
                    {
                        Console.WriteLine("nemoguce");
                        break;
                    }
                    else if (AB > broj_j[i]) { AB -= broj_j[i]; doze[3] += broj_j[i]; }
                    else if (B > broj_j[i]) { B -= broj_j[i]; doze[2] += broj_j[i]; }
                    else if (A > broj_j[i]) { A -= broj_j[i]; doze[1] += broj_j[i]; }
                    else { O -= broj_j[i]; doze[0] += broj_j[i]; }

                }
            }
 
        }
    }
}